#include <fstream>
#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

int Lmax(int nod); 

ifstream fin("subsecvente.in");
ofstream fout("subsecvente.out");

struct Nod {
	Nod() : msk(0), fs(0), fd(0) 
	{
	}
	
	short msk;
	Nod  *fs, *fd;
};

int n, lg, j, s;
string a;
Nod *root;

int Lmax(Nod* nod);
void Insert(Nod* &nod, int i, int j);   // insereaza in arbore secventa [a[i], ..., a[j]] din a 

int main()
{
	fin >> n;
  
    root = new Nod();
    root->msk = (1 << n) - 1;
    
    for (s = 0; s < n ; ++s)    // s - indicele sirului curent
    {
		fin >> a; lg = a.size();
		
		for (int i = 0; i < lg; i++)
        {
            j = min(i + 59, lg - 1);
            
			Insert(root, i, j);
        }
    }
     
    fout << Lmax(root) - 1;
    
    return 0;
}

void Insert(Nod* &nod, int i, int j)
{
	if ( i > j ) return; 
	if ( nod == 0 )
		nod = new Nod();
		
	if ( nod != root )
		nod->msk |= 1 << s;
	
	if ( a[i] == 'a' )
		Insert(nod->fs, i + 1, j);
	else
		Insert(nod->fd, i + 1, j);	
}

int Lmax(Nod* nod)
{ 
    if ( nod == 0 || nod->msk != (1 << n) - 1 )
		return 0;
		
    int la = Lmax(nod->fs);
    int lb = Lmax(nod->fd);
    
    return max(la, lb) + 1; // maximul lungimii fiilor + o muchie
}
