#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;


int Lmax(int nod); 

const int MaxNoduri = 2600100;

int n, j, lg, mask, nod, lit, fiu[2][MaxNoduri];
int msk[MaxNoduri];
char a[50010];

int main()
{
    freopen("subsecvente.in","r", stdin);
    freopen("subsecvente.out","w", stdout);
    scanf("%d\n", &n);
    
    int noduri = 1;
    mask = (1 << n) - 1;  // toate sirurile sunt in masca (11111111...)
    msk[1] = mask;
    
    for (int s = 0; s < n ; ++s)    // s - indicele sirului curent
    {
		scanf("%s", a); 
        lg = strlen(a); 
        
        for (int i = 0; i < lg; i++)
        {
            j = min(i + 59, lg - 1);

			nod = 1;
            for (int k = i; k <= j; k++)
            {
				lit = a[k] - 'a';     // 0 sau 1
				if ( !fiu[lit][nod] )   // daca nu am fiu pentru litera lit
					fiu[lit][nod] = ++noduri; // creez un nou nod
					
				nod = fiu[lit][nod];
				msk[nod] |= 1 << s;     // marcam in nod ca sirul de indice s contine o secventa care se opreste in nod 
			}
        }
    }
    
    printf("%d\n", Lmax(1) - 1);
    
    return 0;
}

int Lmax(int nod)
{ 
    if ( !nod || msk[nod] != mask )
		return 0;
    int la = Lmax(fiu[0][nod]);
    int lb = Lmax(fiu[1][nod]);
    
    return max(la, lb) + 1; // maximul lungimii fiilor + o muchie
}
