#include<stdio.h>
#include<vector>
#include<string.h>

using namespace std;

#define pb push_back
#define lg 300000

int n, m, p1, p2, x, y, poz1, poz2, i, j, teste, ind, tst, s, first[lg], last[lg], stop, x1, x2;
char sir[lg];

vector<int> q[600000], scmb[lg];

struct trie{
	trie * fiu[30];
	int x, y;
	vector<int> v;

	trie(){
		memset(fiu, 0, sizeof(fiu));
		x = y = 0;
	}
};
trie * pref = new trie;
trie * suf = new trie;

void baga(trie * q, int lun){
	if (lun > m){
		q -> v.pb(i);
		return ;
	}

	if (!(q -> fiu[ sir[lun] - 'a' + 1]))
		q -> fiu[ sir[lun] - 'a' + 1] = new trie;

	baga(q -> fiu[ sir[lun] - 'a' + 1], lun + 1);
}
void fix(trie * q){
	ind ++;

	q -> x = ind;

	for (int i = 0; i < q -> v.size(); i ++)
		if (!s)
			first[ q -> v[i] ] = ind;
		else{
			last[ q -> v[i] ] = ind;

			scmb[ first[ q -> v[i] ] ].pb(ind);
		}

	for (int i = 1; i <= 26; i ++)
		if (q -> fiu[i])
			fix(q -> fiu[i]);

	q -> y = ind;
}
void find(trie * q, int lun){
	if (lun > m){
		if (!s)
			p1 = q -> x, p2 = q -> y;
		else
			x = q -> x, y = q -> y;

		return ;
	}

	if (q -> fiu[ sir[lun] - 'a' + 1])
		find(q -> fiu[ sir[lun] - 'a' + 1], lun + 1);
	else
		stop = 1;
}

int bs(int poz, int val){
	int li = 0, ls = q[poz].size() - 1, x, gs = -1;

	while (li <= ls){
		x = (li + ls) / 2;

		if (q[poz][x] <= val){
			gs = x;
			li = x+1;
		}
		else
			ls = x-1;
	}

	return gs;
}

void cstr(int st, int dr, int poz){
	if (st == dr){
		q[poz] = scmb[st];

		return ;
	}

	int x = (st + dr) / 2;

	cstr(st, x, 2 * poz); cstr(x + 1, dr, 2 * poz + 1);

	for (i = 0, j = 0; i < q[2 * poz].size() || j < q[2 * poz + 1].size(); )
		if (i == q[2 * poz].size() || (j < q[2 * poz + 1].size() && q[2 * poz + 1][j] <= q[2 * poz][i]))
			q[poz].pb(q[2 * poz + 1][j]), j ++;
		else
			q[poz].pb(q[2 * poz][i]), i ++;
}
int query(int st, int dr, int poz){
	if (p1 <= st && dr <= p2){
		poz1 = bs(poz, x-1);
		poz2 = bs(poz, y);

		return poz2 - poz1;
	}

	if (p2 < st || p1 > dr)
		return 0;

	int x = (st + dr) / 2;

	return query(st, x, 2 * poz) + query(x + 1, dr, 2 * poz + 1);
}

int main()
{
#ifndef ONLINE_JUDGE
	freopen("ab.in", "rt", stdin);
	freopen("ab.out", "wt", stdout);
#endif

	scanf("%d\n", &n);
	for (i = 1; i <= n; i ++){
		scanf("%s", sir + 1);
		m = strlen(sir + 1);

		baga(pref, 1);

		for (x1 = 1, x2 = m; x1 < x2; x1 ++, x2 --)
			swap(sir[x1], sir[x2]);

		baga(suf, 1);
	}

	fix(pref);
	s = 1; fix(suf);

	cstr(1, ind, 1);

	scanf("%d\n", &teste);
	for (tst = 1; tst <= teste; tst ++){
		stop = 0;

		scanf("%s ", sir + 1); m = strlen(sir + 1);
		s = 0;
		find(pref, 1);

		scanf("%s\n", sir + 1); m = strlen(sir + 1);

		for (x1 = 1, x2 = m; x1 < x2; x1 ++, x2 --)
			swap(sir[x1], sir[x2]);

		s = 1;
		find(suf, 1);

		if (stop == 1)
			printf("0\n");
		else
			printf("%d\n", query(1, ind, 1));
	}

	return 0;
}

